/*
 *	app.h
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO 7 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
//#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

//#define TEXTURE_LIST	PAT0,PAT1,PAT2	/* eNX`Xg */
//#define TEXTURE_COUNT	3		/* eNX`̐ */
#define TEXTURE_LIST	PAT,BG		/* eNX`Xg */
#define TEXTURE_COUNT	2		/* eNX`̐ */

/****************************************************************************
 *	
 ****************************************************************************/

#define CELL_W		(9 + 1)		/* Z   (TCR9+]1) */
#define CELL_H		(9 + 1)		/* Z (TCR9+]1) */

#define FIELD_COLS	6		/* tB[h */
#define FIELD_ROWS	10		/* tB[hs */

#define FIELD_X		5		/* tB[h_XW */
#define FIELD_Y		4		/* tB[h_YW */

typedef struct _GAME {
	int score;			/* XRA */
	int seed;			/* V[h */

	int line;			/* g[^ŃC */
	int down_cnt;			/* tB[h~JE^ */

	int player_stat;		/* vC[(PST_*) */
	int player_cnt;			/* ėpJE^ */
	int player_col;			/* vC[ʒu */
	int player_dice;		/* _CXI */

	int line_num;			/* ŃC */
	int line_cnt;			/* ŃCJE^ */

	int shot_dice;			/* Vbg̖(0:Vbg) */
	int shot_col;			/* Vbgʒu */
	int shot_row;			/* Vbgsʒu */

	int hit_stat;			/* qbg}[N(0:/1:L) */
	int hit_cnt;			/* ėpJE^ */
	int hit_col;			/* qbg}[Nʒu */
	int hit_row;			/* qbg}[Nsʒu */

	int stock[FIELD_COLS];
	int field[FIELD_ROWS][FIELD_COLS];
} GAME;

/* GAME.player_stat */
#define PST_LEFT	1	/* ړ */
#define PST_RIGHT	2	/* Eړ */
#define PST_SHOT	3	/* Vbg */
#define PST_LINE	4	/* C */
#define PST_GAMEOVER	5	/* Q[I[o[ */

//#define FLASH	(!((now >> 1) & 3))	/* _CX_Ń^C~O */
//
#define FLASH	(!(now & (3 << 1)))	/* _CX_Ń^C~O */

#define PLAYER_SPEED	3	/* vC[ړx */

#define LEVEL_LINE	16	/* C1xオ邩 */

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo_main();

void game_init();
void game_main();

void field_disp();
int field_empty();
int field_action();

void player_action();
void shot_action();

void line_test();
int line_erase();

void score_add(int pts);
int down_delay();

void yaku_main();

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
