
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
	.code
	.global ldirect_mkbuf
ldirect_mkbuf:
	ext	0x16		; 	xld.w %r15, 1408		; %r15 = DISP_X / 8 * DISP_Y
	ld.w	%r15,0x0
ldirect_mkbuf_LOOP:
	ld.w %r10, [%r13]+		; %r10 = pixel0to3
	ld.w %r11, [%r13]+		; %r11 = pixel4to7
	sll	%r10,0x4	; 	xsll %r10, 4			; %r10 = pixel0to3 << 4 | pixel4to7
	or %r10, %r11
	ld.w [%r12]+, %r10		; store (pixel0to3 << 4 | pixel4to7)
	sub	%r15,0x1	; 	xsub %r15, %r15, 1
	jrne	ldirect_mkbuf_LOOP	; 	xjrne ldirect_mkbuf_LOOP
	ret

	
	.code
	.global ldirect_trans
ldirect_trans:
	ext	0x0		; 	xld.w %r4, 0x401f5		; %r4 = pSIF3_TXD
	ext	0x1007
	ld.w	%r4,0x35
	ext	0x0		; 	xld.w %r5, 0x401f7		; %r5 = pSIF3_STATUS
	ext	0x1007
	ld.w	%r5,0x37
	ext	0x0		; 	xld.w %r6, 0x402d9		; %r6 = pP2_P2D
	ext	0x100b
	ld.w	%r6,0x19
	;
	ld.w	%r14,0x9	; 	xld.w %r14, 9			; %r14 = page = { 9,8,7,6,5,4,3,2,1,0,15,14,13,12,10 }
ldirect_trans_LOOP_X:
	;
	;	R}hM
	;
	bclr [%r6], 1			; bP2_P2D_P21D = 0
	;
	mirror %r10, %r14		; %r10 = mirror(0xb0 | page)
	or	%r10,0xd	; 	xoor %r10, %r10, 0x0d		;      = 0x0d | mirror(page)
ldirect_trans_L10:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	jreq	ldirect_trans_L10	; 	xjreq ldirect_trans_L10
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	ld.w	%r10,0x8	; 	xld.w %r10, 0x08		; %r10 = mirror(0x10) = 0x08
ldirect_trans_L20:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	jreq	ldirect_trans_L20	; 	xjreq ldirect_trans_L20
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	ld.w	%r10,0x0	; 	xld.w %r10, 0x00		; %r10 = mirror(0x00) = 0x00
ldirect_trans_L30:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	jreq	ldirect_trans_L30	; 	xjreq ldirect_trans_L30
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
ldirect_trans_L40:
	btst [%r5], 5			; while(bSIF3_STATUS_TEND3) { }
	jrne	ldirect_trans_L40	; 	xjrne ldirect_trans_L40
	;
	;	f[^M
	;
	bset [%r6], 1			; bP2_P2D_P21D = 1
	;
	ext	0x1		; 	xld.w %r15, 88			; %r15 = DISP_Y
	ld.w	%r15,0x18
ldirect_trans_LOOP_Y:
	;
	; ȉ̖ߗAC^[bN悤ƂăWX^蓖Ă̕ύX▽߂̕ёւsƁA
	;   Ȃ]vɒxȂ܂BĂȂAOANZXp^[̓ł傤H
	;   Ƃ肠̂܂܂ŁEEE
	;
	ld.ub %r11, [%r12]+		; [4],[0]
	sll	%r11,0x1	; 	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r10, [%r11]
	;
	ld.ub %r11, [%r12]+		; [5],[1]
	sll	%r11,0x1	; 	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r11, [%r11]
	srl	%r10,0x1	; 	xsrl %r10, 1			; *anti-interlock*
	or %r10, %r11
	;
	ld.ub %r11, [%r12]+		; [6],[2]
	sll	%r11,0x1	; 	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r11, [%r11]
	srl	%r10,0x1	; 	xsrl %r10, 1			; *anti-interlock*
	or %r10, %r11
	;
	ld.ub %r11, [%r12]		; [7],[3]
	sll	%r11,0x1	; 	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r11, [%r11]
	srl	%r10,0x1	; 	xsrl %r10, 1			; *anti-interlock*
	or %r10, %r11
	;
ldirect_trans_L50:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	jreq	ldirect_trans_L50	; 	xjreq ldirect_trans_L50
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	add	%r12,0x3d	; 	xadd %r12, %r12, 61		; %r12 += (DISP_X / 2) - (8 / 2 - 1)
	srl	%r10,0x8	; 	xsrl %r10, 8			; %r10 >>= 8
	;
ldirect_trans_L60:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	jreq	ldirect_trans_L60	; 	xjreq ldirect_trans_L60
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	sub	%r15,0x1	; 	xsub %r15, %r15, 1
	jrne	ldirect_trans_LOOP_Y	; 	xjrne ldirect_trans_LOOP_Y
	;
	ext	0x57		; 	xsub %r12, %r12, 5628		; wbuff += (8 / 2) - (DISP_X / 2 * DISP_Y)
	sub	%r12,0x3c
	sub	%r14,0x1	; 	xsub %r14, %r14, 1		; page = (page - 1) & 15
	and	%r14,0xf	; 	xand %r14, %r14, 15
	;
ldirect_trans_L70:
	btst [%r5], 5			; while(bSIF3_STATUS_TEND3) { }
	jrne	ldirect_trans_L70	; 	xjrne ldirect_trans_L70
	;
	cmp	%r14,0x9	; 	xcmp %r14, 9
	jrne	ldirect_trans_LOOP_X	; 	xjrne ldirect_trans_LOOP_X
	;
	ret

; NO_APP
	.code
	.align	1
	.global	PDW_Draw_4BN
PDW_Draw_4BN:
;	.frame	%sp,16,$31		# vars= 0, regs= 4/0, args= 0, extra= 0
;	.mask	0x80070000,-4
;	.fmask	0x00000000,0
	pushn	%r2
	ld.uh	%r11,[%sp+0x10]	; 	xld.uh	%r11,[%sp+0x20]
	ld.w	%r7,%r11
	and	%r7,0x7		; 	xand	%r7,%r7,0x00000007
	ld.w	%r15,[%sp+0x7]	; 	xld.w	%r15,[%sp+0x1c]
	ext	0xa		; 	xld.h	%r13,[%r15+0xa]
	ld.h	%r13,[%r15]
	ld.h	%r10,[%sp+0x11]	; 	xld.h	%r10,[%sp+0x22]
	MLT.H	%r13,%r10
	ld.h	%r11,%r11
	ld.w	%r12,%alr
	add	%r12,%r11
	jrge	__LX27		; 	xjrge	__L27
	add	%r12,0x7	; 	xadd	%r12,%r12,7
__LX27:				; __L27:
	sra	%r12,0x3	; 	xsra	%r12,3
	ld.w	%r11,%r12
	sll	%r11,0x2	; 	xsll	%r11,2
	ext	0x14		; 	xld.w	%r10,[%r15+0x14]
	ld.w	%r10,[%r15]
	ld.w	%r4,%r10
	add	%r4,%r11
	ext	0x18		; 	xld.w	%r10,[%r15+0x18]
	ld.w	%r10,[%r15]
	ld.w	%r5,%r10
	add	%r5,%r12
	ld.w	%r10,%r13
	cmp	%r10,0x0
	jrge	__LX28		; 	xjrge	__L28
	add	%r10,0x7	; 	xadd	%r10,%r10,7
__LX28:				; __L28:
	ld.w	%r12,%r10
	sra	%r12,0x3	; 	xsra	%r12,3
	ld.h	%r14,[%sp+0xc]	; 	xld.h	%r14,[%sp+0x18]
	ld.w	%r11,%r7
	add	%r11,%r14
	ext	0x1		; 	xsub	%r10,%r11,1
	sub	%r10,%r11
	jrge	__LX29		; 	xjrge	__L29
	ext	0x6		; 	xadd	%r10,%r11,6
	add	%r10,%r11
__LX29:				; __L29:
	sra	%r10,0x3	; 	xsra	%r10,3
	ld.w	%r0,%r12
	sub	%r0,%r10
	ld.h	%r6,[%sp+0xd]	; 	xld.h	%r6,[%sp+0x1a]
	ld.ub	%r10,[%sp+0x29]	; 	xld.ub	%r10,[%sp+0x29]
	ext	0x1		; 	xld.w	%r11,0x00000040		; 64
	ld.w	%r11,0x0
	cmp	%r10,%r11
	ext	__LX145@rm	; 	xjreq	__L145
	jreq	__LX145@rl
	jrgt	__LX261		; 	xjrgt	__L261
	cmp	%r10,0x0
	jreq	__LX31		; 	xjreq	__L31
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX261:				; __L261:
	ext	0x2		; 	xcmp	%r10,128
	cmp	%r10,0x0
	ext	__LX88@rm	; 	xjreq	__L88
	jreq	__LX88@rl
	ext	0x3		; 	xcmp	%r10,192
	cmp	%r10,0x0
	ext	__LX202@rm	; 	xjreq	__L202
	jreq	__LX202@rl
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX31:				; __L31:
	ld.w	%r11,[%sp+0x4]	; 	xld.w	%r11,[%sp+0x10]
	ld.h	%r12,[%r11]	; 	xld.h	%r12,[%r11]
	ld.h	%r10,[%sp+0xb]	; 	xld.h	%r10,[%sp+0x16]
	MLT.H	%r12,%r10
	ext	0x4		; 	xld.w	%r10,[%r11+0x4]
	ld.w	%r10,[%r11]
	ld.w	%r2,%alr
	add	%r10,%r2
	ld.h	%r11,[%sp+0xa]	; 	xld.h	%r11,[%sp+0x14]
	ld.w	%r13,%r10
	add	%r13,%r11
	sub	%r12,%r14
	ext	0x9		; 	xld.ub	%r10,[%r15+0x9]
	ld.ub	%r10,[%r15]
	cmp	%r10,0x0
	ext	__LX32@rm	; 	xjreq	__L32
	jreq	__LX32@rl
	ext	__L62+0x0@h	; 	xld.w	%r11,__L62
	ext	__L62+0x0@m
	ld.w	%r11,__L62+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r1,%r10
	add	%r1,%r11
__LX33:				; __L33:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX59		; 	xjrugt	__L59
	ld.w	%r10,[%r1]	; 	xld.w	%r10,[%r1]
	jp	%r10
	.code
	.align	2
__L62:
	.word	__L38
	.word	__L41
	.word	__L44
	.word	__L47
	.word	__L50
	.word	__L53
	.word	__L56
	.code
__LX37:				; __L37:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
__L38:
	ld.w	%r10,%r15
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	jreq	__LX39		; 	xjreq	__L39
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX39:				; __L39:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__L41:
	ld.w	%r10,%r15
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	jreq	__LX42		; 	xjreq	__L42
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX42:				; __L42:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__L44:
	ld.w	%r10,%r15
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jreq	__LX45		; 	xjreq	__L45
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX45:				; __L45:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__L47:
	ld.w	%r10,%r15
	and	%r10,0x10	; 	xand	%r10,%r10,0x00000010
	jreq	__LX48		; 	xjreq	__L48
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX48:				; __L48:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__L50:
	ld.w	%r10,%r15
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	jreq	__LX51		; 	xjreq	__L51
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX51:				; __L51:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__L53:
	ld.w	%r10,%r15
	and	%r10,0x4	; 	xand	%r10,%r10,0x00000004
	jreq	__LX54		; 	xjreq	__L54
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX54:				; __L54:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__L56:
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	jreq	__LX57		; 	xjreq	__L57
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX57:				; __L57:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX36		; 	xjreq	__L36
__LX59:				; __L59:
	ld.w	%r10,%r15
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX60		; 	xjreq	__L60
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX60:				; __L60:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX37		; 	xjrne	__L37
__LX36:				; __L36:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	add	%r5,%r0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX33		; 	xjrne	__L33
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX32:				; __L32:
	ext	__L86+0x0@h	; 	xld.w	%r11,__L86
	ext	__L86+0x0@m
	ld.w	%r11,__L86+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r15,%r10
	add	%r15,%r11
__LX65:				; __L65:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX84		; 	xjrugt	__L84
	ld.w	%r10,[%r15]	; 	xld.w	%r10,[%r15]
	jp	%r10
	.code
	.align	2
__L86:
	.word	__L70
	.word	__L72
	.word	__L74
	.word	__L76
	.word	__L78
	.word	__L80
	.word	__L82
	.code
__LX69:				; __L69:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
__L70:
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__L72:
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__L74:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__L76:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__L78:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__L80:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__L82:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX68		; 	xjreq	__L68
__LX84:				; __L84:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX69		; 	xjrne	__L69
__LX68:				; __L68:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX65		; 	xjrne	__L65
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX88:				; __L88:
	ld.w	%r11,[%sp+0x4]	; 	xld.w	%r11,[%sp+0x10]
	ld.h	%r12,[%r11]	; 	xld.h	%r12,[%r11]
	ld.h	%r10,[%sp+0xb]	; 	xld.h	%r10,[%sp+0x16]
	MLT.H	%r12,%r10
	ext	0x4		; 	xld.w	%r10,[%r11+0x4]
	ld.w	%r10,[%r11]
	ld.w	%r2,%alr
	add	%r10,%r2
	ld.h	%r11,[%sp+0xa]	; 	xld.h	%r11,[%sp+0x14]
	add	%r10,%r11
	add	%r10,%r14
	ext	0x1		; 	xsub	%r13,%r10,1
	sub	%r13,%r10
	add	%r12,%r14
	ext	0x9		; 	xld.ub	%r10,[%r15+0x9]
	ld.ub	%r10,[%r15]
	cmp	%r10,0x0
	ext	__LX89@rm	; 	xjreq	__L89
	jreq	__LX89@rl
	ext	__L119+0x0@h	; 	xld.w	%r11,__L119
	ext	__L119+0x0@m
	ld.w	%r11,__L119+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r1,%r10
	add	%r1,%r11
__LX90:				; __L90:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX116		; 	xjrugt	__L116
	ld.w	%r10,[%r1]	; 	xld.w	%r10,[%r1]
	jp	%r10
	.code
	.align	2
__L119:
	.word	__L95
	.word	__L98
	.word	__L101
	.word	__L104
	.word	__L107
	.word	__L110
	.word	__L113
	.code
__LX94:				; __L94:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
__L95:
	ld.w	%r10,%r15
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	jreq	__LX96		; 	xjreq	__L96
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX96:				; __L96:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__L98:
	ld.w	%r10,%r15
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	jreq	__LX99		; 	xjreq	__L99
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX99:				; __L99:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__L101:
	ld.w	%r10,%r15
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jreq	__LX102		; 	xjreq	__L102
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX102:				; __L102:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__L104:
	ld.w	%r10,%r15
	and	%r10,0x10	; 	xand	%r10,%r10,0x00000010
	jreq	__LX105		; 	xjreq	__L105
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX105:				; __L105:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__L107:
	ld.w	%r10,%r15
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	jreq	__LX108		; 	xjreq	__L108
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX108:				; __L108:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__L110:
	ld.w	%r10,%r15
	and	%r10,0x4	; 	xand	%r10,%r10,0x00000004
	jreq	__LX111		; 	xjreq	__L111
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX111:				; __L111:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__L113:
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	jreq	__LX114		; 	xjreq	__L114
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX114:				; __L114:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX93		; 	xjreq	__L93
__LX116:				; __L116:
	ld.w	%r10,%r15
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX117		; 	xjreq	__L117
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX117:				; __L117:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX94		; 	xjrne	__L94
__LX93:				; __L93:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	add	%r5,%r0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX90		; 	xjrne	__L90
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX89:				; __L89:
	ext	__L143+0x0@h	; 	xld.w	%r11,__L143
	ext	__L143+0x0@m
	ld.w	%r11,__L143+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r15,%r10
	add	%r15,%r11
__LX122:				; __L122:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX141		; 	xjrugt	__L141
	ld.w	%r10,[%r15]	; 	xld.w	%r10,[%r15]
	jp	%r10
	.code
	.align	2
__L143:
	.word	__L127
	.word	__L129
	.word	__L131
	.word	__L133
	.word	__L135
	.word	__L137
	.word	__L139
	.code
__LX126:				; __L126:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
__L127:
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__L129:
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__L131:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__L133:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__L135:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__L137:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__L139:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX125		; 	xjreq	__L125
__LX141:				; __L141:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX126		; 	xjrne	__L126
__LX125:				; __L125:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX122		; 	xjrne	__L122
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX145:				; __L145:
	ld.w	%r11,[%sp+0x4]	; 	xld.w	%r11,[%sp+0x10]
	ld.h	%r12,[%r11]	; 	xld.h	%r12,[%r11]
	ld.h	%r10,[%sp+0xb]	; 	xld.h	%r10,[%sp+0x16]
	add	%r10,%r6
	sub	%r10,0x1	; 	xsub	%r10,%r10,1
	MLT.H	%r12,%r10
	ext	0x4		; 	xld.w	%r10,[%r11+0x4]
	ld.w	%r10,[%r11]
	ld.w	%r2,%alr
	add	%r10,%r2
	ld.h	%r11,[%sp+0xa]	; 	xld.h	%r11,[%sp+0x14]
	ld.w	%r13,%r10
	add	%r13,%r11
	not	%r12,%r12
	add	%r12,1
	sub	%r12,%r14
	ext	0x9		; 	xld.ub	%r10,[%r15+0x9]
	ld.ub	%r10,[%r15]
	cmp	%r10,0x0
	ext	__LX146@rm	; 	xjreq	__L146
	jreq	__LX146@rl
	ext	__L176+0x0@h	; 	xld.w	%r11,__L176
	ext	__L176+0x0@m
	ld.w	%r11,__L176+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r1,%r10
	add	%r1,%r11
__LX147:				; __L147:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX173		; 	xjrugt	__L173
	ld.w	%r10,[%r1]	; 	xld.w	%r10,[%r1]
	jp	%r10
	.code
	.align	2
__L176:
	.word	__L152
	.word	__L155
	.word	__L158
	.word	__L161
	.word	__L164
	.word	__L167
	.word	__L170
	.code
__LX151:				; __L151:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
__L152:
	ld.w	%r10,%r15
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	jreq	__LX153		; 	xjreq	__L153
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX153:				; __L153:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__L155:
	ld.w	%r10,%r15
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	jreq	__LX156		; 	xjreq	__L156
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX156:				; __L156:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__L158:
	ld.w	%r10,%r15
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jreq	__LX159		; 	xjreq	__L159
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX159:				; __L159:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__L161:
	ld.w	%r10,%r15
	and	%r10,0x10	; 	xand	%r10,%r10,0x00000010
	jreq	__LX162		; 	xjreq	__L162
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX162:				; __L162:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__L164:
	ld.w	%r10,%r15
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	jreq	__LX165		; 	xjreq	__L165
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX165:				; __L165:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__L167:
	ld.w	%r10,%r15
	and	%r10,0x4	; 	xand	%r10,%r10,0x00000004
	jreq	__LX168		; 	xjreq	__L168
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX168:				; __L168:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__L170:
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	jreq	__LX171		; 	xjreq	__L171
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX171:				; __L171:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX150		; 	xjreq	__L150
__LX173:				; __L173:
	ld.w	%r10,%r15
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX174		; 	xjreq	__L174
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX174:				; __L174:
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX151		; 	xjrne	__L151
__LX150:				; __L150:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	add	%r5,%r0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX147		; 	xjrne	__L147
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX146:				; __L146:
	ext	__L200+0x0@h	; 	xld.w	%r11,__L200
	ext	__L200+0x0@m
	ld.w	%r11,__L200+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r15,%r10
	add	%r15,%r11
__LX179:				; __L179:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX198		; 	xjrugt	__L198
	ld.w	%r10,[%r15]	; 	xld.w	%r10,[%r15]
	jp	%r10
	.code
	.align	2
__L200:
	.word	__L184
	.word	__L186
	.word	__L188
	.word	__L190
	.word	__L192
	.word	__L194
	.word	__L196
	.code
__LX183:				; __L183:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
__L184:
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__L186:
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__L188:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__L190:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__L192:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__L194:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__L196:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX182		; 	xjreq	__L182
__LX198:				; __L198:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX183		; 	xjrne	__L183
__LX182:				; __L182:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX179		; 	xjrne	__L179
	ext	__LX30@rm	; 	xjp	__L30
	jp	__LX30@rl
__LX202:				; __L202:
	ld.w	%r11,[%sp+0x4]	; 	xld.w	%r11,[%sp+0x10]
	ld.h	%r12,[%r11]	; 	xld.h	%r12,[%r11]
	ld.h	%r10,[%sp+0xb]	; 	xld.h	%r10,[%sp+0x16]
	add	%r10,%r6
	sub	%r10,0x1	; 	xsub	%r10,%r10,1
	MLT.H	%r12,%r10
	ext	0x4		; 	xld.w	%r10,[%r11+0x4]
	ld.w	%r10,[%r11]
	ld.w	%r2,%alr
	add	%r10,%r2
	ld.h	%r11,[%sp+0xa]	; 	xld.h	%r11,[%sp+0x14]
	add	%r10,%r11
	add	%r10,%r14
	ext	0x1		; 	xsub	%r13,%r10,1
	sub	%r13,%r10
	sub	%r14,%r12
	ld.w	%r12,%r14
	ext	0x9		; 	xld.ub	%r10,[%r15+0x9]
	ld.ub	%r10,[%r15]
	cmp	%r10,0x0
	ext	__LX203@rm	; 	xjreq	__L203
	jreq	__LX203@rl
	ext	__L233+0x0@h	; 	xld.w	%r11,__L233
	ext	__L233+0x0@m
	ld.w	%r11,__L233+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r1,%r10
	add	%r1,%r11
__LX204:				; __L204:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX230		; 	xjrugt	__L230
	ld.w	%r10,[%r1]	; 	xld.w	%r10,[%r1]
	jp	%r10
	.code
	.align	2
__L233:
	.word	__L209
	.word	__L212
	.word	__L215
	.word	__L218
	.word	__L221
	.word	__L224
	.word	__L227
	.code
__LX208:				; __L208:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	add	%r5,0x1		; 	xadd	%r5,%r5,1
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
__L209:
	ld.w	%r10,%r15
	ext	0x2		; 	xand	%r10,%r10,0x00000080
	and	%r10,0x0
	jreq	__LX210		; 	xjreq	__L210
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX210:				; __L210:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__L212:
	ld.w	%r10,%r15
	ext	0x1		; 	xand	%r10,%r10,0x00000040
	and	%r10,0x0
	jreq	__LX213		; 	xjreq	__L213
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX213:				; __L213:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__L215:
	ld.w	%r10,%r15
	ext	0x0		; 	xand	%r10,%r10,0x00000020
	and	%r10,0x20
	jreq	__LX216		; 	xjreq	__L216
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX216:				; __L216:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__L218:
	ld.w	%r10,%r15
	and	%r10,0x10	; 	xand	%r10,%r10,0x00000010
	jreq	__LX219		; 	xjreq	__L219
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX219:				; __L219:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__L221:
	ld.w	%r10,%r15
	and	%r10,0x8	; 	xand	%r10,%r10,0x00000008
	jreq	__LX222		; 	xjreq	__L222
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX222:				; __L222:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__L224:
	ld.w	%r10,%r15
	and	%r10,0x4	; 	xand	%r10,%r10,0x00000004
	jreq	__LX225		; 	xjreq	__L225
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX225:				; __L225:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__L227:
	ld.w	%r10,%r15
	and	%r10,0x2	; 	xand	%r10,%r10,0x00000002
	jreq	__LX228		; 	xjreq	__L228
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX228:				; __L228:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX207		; 	xjreq	__L207
__LX230:				; __L230:
	ld.w	%r10,%r15
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	jreq	__LX231		; 	xjreq	__L231
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
__LX231:				; __L231:
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX208		; 	xjrne	__L208
__LX207:				; __L207:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	add	%r5,%r0
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX204		; 	xjrne	__L204
	jp	__LX30		; 	xjp	__L30
__LX203:				; __L203:
	ext	__L257+0x0@h	; 	xld.w	%r11,__L257
	ext	__L257+0x0@m
	ld.w	%r11,__L257+0x0@l
	ld.w	%r10,%r7
	sll	%r10,0x2	; 	xsll	%r10,2
	ld.w	%r15,%r10
	add	%r15,%r11
__LX236:				; __L236:
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
	ld.h	%r11,[%sp+0xc]	; 	xld.h	%r11,[%sp+0x18]
	cmp	%r7,0x6		; 	xcmp	%r7,6
	jrugt	__LX255		; 	xjrugt	__L255
	ld.w	%r10,[%r15]	; 	xld.w	%r10,[%r15]
	jp	%r10
	.code
	.align	2
__L257:
	.word	__L241
	.word	__L243
	.word	__L245
	.word	__L247
	.word	__L249
	.word	__L251
	.word	__L253
	.code
__LX240:				; __L240:
	add	%r4,0x4		; 	xadd	%r4,%r4,4
	ld.w	%r14,[%r4]	; 	xld.w	%r14,[%r4]
__L241:
	ld.w	%r10,%r14
	srl	%r10,0x4	; 	xsrl	%r10,4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__L243:
	ld.w	%r10,%r14
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__L245:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,12
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__L247:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__L249:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,20
	srl	%r10,0x8
	srl	%r10,0x4
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__L251:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,16
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__L253:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,28
	srl	%r10,0x8
	srl	%r10,0x8
	srl	%r10,0x4
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jreq	__LX239		; 	xjreq	__L239
__LX255:				; __L255:
	ld.w	%r10,%r14
	srl	%r10,0x8	; 	xsrl	%r10,24
	srl	%r10,0x8
	srl	%r10,0x8
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.b	[%r13],%r10	; 	xld.b	[%r13],%r10
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	sub	%r11,0x1	; 	xsub	%r11,%r11,1
	jrne	__LX240		; 	xjrne	__L240
__LX239:				; __L239:
	add	%r13,%r12
	ld.w	%r10,%r0
	sll	%r10,0x2	; 	xsll	%r10,2
	add	%r4,%r10
	sub	%r6,0x1		; 	xsub	%r6,%r6,1
	jrne	__LX236		; 	xjrne	__L236
__LX30:				; __L30:
	popn	%r2
	ret
